using System;
using System.Collections.Generic;
using System.Text;
using System.Xml.Serialization;
using System.IO;

namespace Serialization2
{
    class Program
    {
        static void Main(string[] args)
        {
            Program serializer = new Program();

            Information info = new Information();
            List<Project> projList = new List<Project>();
            Project projectOne = new Project();
            Project projectTwo = new Project();

            projectOne.Username = "user1";
            projectOne.Password = "pass1";
            projectOne.ProjUrl  = "http://addr1.com";
            projectOne.ProjName = "name1";

            projectTwo.Username = "user2";
            projectTwo.Password = "pass2";
            projectTwo.ProjUrl = "http://addr2.com";
            projectTwo.ProjName = "name2";

            projList.Add(projectOne);
            projList.Add(projectTwo);
            info.ProjectCredentials = projList;

            serializer.WriteCredentials(info);
            serializer.ReadCredentials();

            Console.Read();
        }

        public void WriteCredentials(Information projectsInfo)
        {
            TextWriter tw = new StreamWriter("credentials.xml");
            XmlSerializer sr = new XmlSerializer(typeof(Information));
            sr.Serialize(tw, projectsInfo);
            tw.Close();
        }

        public void ReadCredentials()
        {
            TextReader tr = new StreamReader("credentials.xml");
            XmlSerializer sr = new XmlSerializer(typeof(Information));
            Information projectInfo = (Information)sr.Deserialize(tr);
            tr.Close();

            foreach (Project project in projectInfo.ProjectCredentials)
            {
                Console.WriteLine(project.Username + " " + project.Password + " " + project.ProjUrl + " " + project.ProjName);
            }
        }
    }

    [XmlRoot("Information")]
    public class Information
    {
        List<Project> _projectCredentials;

        public List<Project> ProjectCredentials
        {
            get { return _projectCredentials; }
            set { _projectCredentials = value; }
        }
    }

    [XmlRoot("Project")]
    public class Project
    {
        string _username;
        string _password;
        string _projUrl;
        string _projName;

        [XmlElement("Username")]
        public string Username
        {
            get { return _username; }
            set { _username = value; }
        }

        [XmlElement("Password")]
        public string Password
        {
            get { return _password; }
            set { _password = value; }
        }

        [XmlElement("Url")]
        public string ProjUrl
        {
            get { return _projUrl; }
            set { _projUrl = value; }
        }

        [XmlAttribute("name")]
        public string ProjName
        {
            get { return _projName; }
            set { _projName = value; }
        }
    }
}
